<template>
  <form class="row needs-validation" novalidate>
    <div class="col-2 pe-0 ps-0">
      <div class="input-group input-group-sm pe-0 ps-0">
        <input id="expte_origen" type="text" placeholder="Origen" autocomplete="off"
          class="form-control text-center remove-border" :class="{ 'is-invalid': formErrores.origen }"
          v-model.trim="form.expediente.origen" :disabled="filtrosDisabled.origen" @input="clearExpediente()" />
        <span class="input-group-text d-none d-sm-block" style="border-radius: 0px;"> - </span>
        <div class="invalid-feedback d-none d-sm-block" v-if="formErrores.origen">
          Ingrese un origen v&aacute;lido
        </div>
      </div>
    </div>
    <div class="col-3 pe-0 ps-0">
      <div class="input-group input-group-sm pe-0 ps-0">
        <input id="expte_numero" type="text" placeholder="Número" autocomplete="off"
          class="form-control text-center remove-border" :class="{ 'is-invalid': formErrores.numero }"
          v-model="form.expediente.numero" :disabled="filtrosDisabled.general" @input="clearExpediente()" />
        <span class="input-group-text d-none d-sm-block" style="border-radius: 0px;"> / </span>
        <div class="invalid-feedback d-none d-sm-block" v-if="formErrores.numero">
          Ingrese un n&uacute;mero v&aacute;lido
        </div>
      </div>
    </div>
    <div class="col-3 pe-0 ps-0">
      <div class="input-group input-group-sm pe-0 ps-0">
        <input id="expte_anio" type="text" placeholder="Año" autocomplete="off"
          class="form-control text-center remove-border" :class="{ 'is-invalid': formErrores.anio }"
          v-model.trim="form.expediente.anio" :disabled="filtrosDisabled.general" @input="clearExpediente()" />
        <span class="input-group-text d-none d-sm-block" style="border-radius: 0px;"> - </span>
        <div class="invalid-feedback d-none d-sm-block" v-if="formErrores.anio">
          Ingrese un a&ntilde;o v&aacute;lido
        </div>
      </div>
    </div>
    <div class="col-2 pe-0 ps-0">
      <div class="input-group input-group-sm pe-0 ps-0">
        <input id="expte_alcance" type="text" placeholder="Alcance" autocomplete="off"
          class="form-control text-center remove-border" :class="{ 'is-invalid': formErrores.alcance }"
          v-model="form.expediente.alcance" :disabled="filtrosDisabled.general" @input="clearExpediente()" />
        <div class="invalid-feedback d-none d-sm-block" v-if="formErrores.alcance">
          Ingrese un alcance v&aacute;lido
        </div>
      </div>
    </div>
    <div class="col pe-0 ps-2">
      <div v-show="filtrosShow.buscar" class="input-group input-group-sm">
        <button type="button" class="btn btn-secondary text-white" alt="Buscar/Validar expediente"
          title="Buscar/Validar expediente" @click="validateForm()">
          <i class="bi bi-search"></i>
        </button>
      </div>
      <div v-show="filtrosShow.cargando" class="spinner-border text-secondary" role="status">
        <span class="visually-hidden">Cargando...</span>
      </div>
      <div v-show="filtrosShow.exito" class="input-group input-group-sm">
        <button disabled type="button" class="btn btn-success text-white" alt="&Eacute;xito" title="&Eacute;xito">
          <i class="bi bi-check-lg"></i>
        </button>
      </div>
      <div v-show="filtrosShow.fallo" class="input-group input-group-sm">
        <button disabled type="button" class="btn btn-danger text-white" alt="Fallo" title="Fallo">
          <i class="bi bi-x-lg"></i>
        </button>
      </div>
    </div>
  </form>
</template>

<script setup lang="ts">
import { onMounted, reactive, computed, watch, watchEffect } from 'vue';
//import http from "@/http";
//import axios from 'axios';
//import type { AxiosResponse, AxiosError } from 'axios';
import Swal from "sweetalert2/dist/sweetalert2.js";
import type { SweetAlertOptions } from "sweetalert2";
import { isEmpty, isNumber, Expediente, /*type ExpedienteInterface*/ useExpedientesStore } from "../../index";

const expedientesStore = useExpedientesStore();

const props = withDefaults(defineProps<{
  //modelValue: ExpedienteInterface | null,
  modelValue: Expediente,
  //validate?: boolean,
  urlServer?: string,
  tipo?: string,
  disabled?: boolean,
  disabledOrigen?: boolean
}>(), {
  modelValue: Object.create({}),
  //validate: false,
  disabled: false,
  disabledOrigen: false
});

const emits = defineEmits(["update:modelValue"]);

const tiposTablas = [
  'B', // 'Becas'
  'S', // 'Subsidios'
  'N', // 'Nombramientos'
  'A', // 'Administrativos'
  'P'  // 'Proyectos Legislativos'
];

const resetFormEstado = () => {
  formEstado.isSearching = false;
  formEstado.isUpdated = true;
  setTimeout(() => {
    formEstado.isSuccess = null;
  }, 1000);
};

/*
const formulario = reactive({
  origen: undefined as string | undefined,
  numero: undefined as string | undefined,
  anio: undefined as string | undefined,
  alcance: undefined as string | undefined
});
*/

const form = reactive({
  expediente: computed({
    get() {
      return props.modelValue;
    },
    set(value) {
      emits('update:modelValue', value);
    }
  })
});

const formEstado = reactive({
  isSearching: false,
  isUpdated: true,
  isSuccess: null as boolean | null
  //init: true as boolean,
});

const formErrores = reactive({
  origen: false as boolean,
  numero: false as boolean,
  anio: false as boolean,
  alcance: false as boolean
} as Record<string, boolean>);

const filtrosDisabled = computed(() => {
  return {
    general: props.disabled || formEstado.isSuccess !== null || formEstado.isSearching,
    origen: props.disabled || props.disabledOrigen || formEstado.isSuccess !== null || formEstado.isSearching
  }
});
const filtrosShow = computed(() => {
  return {
    buscar: !formEstado.isUpdated && !formEstado.isSearching,
    cargando: formEstado.isSearching,
    exito: formEstado.isSuccess === true,
    fallo: formEstado.isSuccess === false
  }
});

onMounted(() => {
  const swal = {
    icon: "error",
    title: "Error",
    html: "",
  } as SweetAlertOptions;
  if (isEmpty(props.urlServer)) {
    swal.html =
      'La "urlServer" indicada para el endpoint de validaci&oacute;n del expediente no es v&aacute;lida. Por favor, avise al Administrador.';
  } else if ((isEmpty(props.tipo)) || (tiposTablas.indexOf(String(props.tipo)) === -1)) {
    swal.html = "El tipo indicado para la validaci&oacute;n del expediente no es v&aacute;lido. Por favor, avise al Administrador.";
  }
  if (!isEmpty(swal.html)) {
    Swal.fire(swal);
    throw new Error(String(swal.html));
  }
  expedientesStore.setUrlServer(props.urlServer!);
  /*
  if (!isEmpty(form.expediente.id)) {
    findExpedienteById();
  } else if (!isEmpty(form.expediente.origen) && !isEmpty(form.expediente.numero) && !isEmpty(form.expediente.anio) && !isEmpty(form.expediente.alcance)) {
    findExpediente();
  } else if (isEmpty(expedientesStore.getExpedientes())) {
    fetchExpedientes();
  }
  */
  if ((!isEmpty(form.expediente.id)) ||
    (!isEmpty(form.expediente.origen) && !isEmpty(form.expediente.numero) && !isEmpty(form.expediente.anio) && !isEmpty(form.expediente.alcance))
  ) {
    fetchExpediente();
  }
});

/*
async function fetchExpedientes() {
  formEstado.isSearching = true;
  await expedientesStore.fetchExpedientes({ tipo: props.tipo });
  formEstado.isSearching = false;
}
*/

async function fetchExpediente() {
  const paramsRequest: Record<string, any> = isEmpty(form.expediente.id) ? {
    origen: form.expediente.origen, numero: Number(form.expediente.numero), anio: form.expediente.anio, alcance: Number(form.expediente.alcance)
  } : {
    id: form.expediente.id
  };
  let isSuccess: boolean = true;
  formEstado.isSearching = true;
  paramsRequest.tipo = props.tipo;
  isSuccess = await expedientesStore.fetchExpediente(paramsRequest);
  form.expediente = isSuccess ? expedientesStore.getExpediente()! : form.expediente;
  formEstado.isSuccess = isSuccess;
  resetFormEstado();
}

/*
async function findExpediente() {
  let expedienteAux: Expediente | null = null;
  formEstado.isSearching = true;
  expedienteAux = await expedientesStore.findExpediente(
    { origen: form.expediente.origen!, numero: Number(form.expediente.numero), anio: form.expediente.anio!, alcance: Number(form.expediente.alcance) },
    false, {
      tipo: props.tipo 
      //, origen: form.expediente.origen, numero: form.expediente.numero, anio: form.expediente.anio, alcance: form.expediente.alcance
    }
  );
  form.expediente = !isEmpty(expedienteAux) ? expedienteAux! : form.expediente;
  formEstado.isSuccess = !isEmpty(expedienteAux);
  resetFormEstado();
}

async function findExpedienteById() {
  let expedienteAux: Expediente | null = null;
  formEstado.isSearching = true;
  expedienteAux = await expedientesStore.findExpedienteById(
    Number(form.expediente.id),
    false, { 
      tipo: props.tipo 
      //, id: form.expediente.id
    }
  );
  form.expediente = !isEmpty(expedienteAux) ? expedienteAux! : form.expediente;
  formEstado.isSuccess = !isEmpty(expedienteAux);
  resetFormEstado();
}
*/

/*
const emit = defineEmits<{
  (e: "update:model-value", elem: Expediente | null): void
}>();

onMounted(() => {
  if (props.validate) {
    if (props.tipo == undefined || tiposTablas.indexOf(props.tipo) == -1) {
      throw new Error("El tipo indicado no es válido.");
    }

    if (props.urlServer == undefined || props.urlServer.trim() == "") {
      throw new Error("Debe indicar la 'urlServer' del endpoint de validación.");
    }
  }
  initForm();
});

function initForm() {
  formulario.origen = (props.modelValue != null && 'origen' in props.modelValue) ? props.modelValue.origen?.toString() : undefined; // TEXTO MAX 5 CARAC
  formulario.numero = (props.modelValue != null && 'numero' in props.modelValue) ? props.modelValue.numero?.toString() : undefined;; // NUMERO 6 DIGITOS
  formulario.anio = (props.modelValue != null && 'anio' in props.modelValue) ? props.modelValue.anio?.toString() : undefined; // TEXTO MAX 5 CARAC
  formulario.alcance = (props.modelValue != null && 'alcance' in props.modelValue) ? props.modelValue.alcance?.toString() : undefined;; // NUMERO 3 DIGITOS
}
*/

function validateForm() {
  let isValid: boolean = true;
  let length: number;
  const numeroStr: string = String(form.expediente.numero);
  const alcanceStr: string = String(form.expediente.alcance);

  formErrores.origen = false;
  if (form.expediente.origen != undefined) {
    length = form.expediente.origen.length;
    if (length == 0 || length > 5) {
      isValid = false;
      formErrores.origen = true;
    }
  } else {
    formErrores.origen = true;
    isValid = false;
  }

  formErrores.numero = false;
  if (form.expediente.numero != undefined) {
    length = numeroStr.length;
    if (length == 0 || length > 6) {
      formErrores.numero = true;
      isValid = false;
    } else if (!isNumber(numeroStr)) {
      formErrores.numero = true;
      isValid = false;
    }
  } else {
    formErrores.numero = true;
    isValid = false;
  }

  formErrores.anio = false;
  if (form.expediente.anio != undefined) {
    length = form.expediente.anio.length;
    if (length == 0 || length > 5) {
      formErrores.anio = true;
      isValid = false;
    }
  } else {
    formErrores.anio = true;
    isValid = false;
  }

  formErrores.alcance = false;
  if (form.expediente.alcance != undefined) {
    length = alcanceStr.length;
    if (length == 0 || length > 3) {
      formErrores.alcance = true;
      isValid = false;
    } else if (!isNumber(alcanceStr)) {
      formErrores.alcance = true;
      isValid = false;
    }
  } else {
    formErrores.alcance = true;
    isValid = false;
  }

  if (isValid) {
    //findExpediente();
    fetchExpediente();
  } else {
    setTimeout(() => {
      Object.keys(formErrores).filter(
        (key) => formErrores[key]
      ).forEach(
        (filteredKey) => formErrores[filteredKey] = false
      );
    }, 1000);
  }

}

/*
async function getExpediente(): Promise<Expediente | null> {
  var rtaExp: Expediente | null = null;
  formEstado.isSearching = true;
  try {
    var response = await axios.get(props.urlServer + "getExpedientesGenerico", {
      params: {
        tipo: props.tipo,
        origen: formulario.origen,
        numero: formulario.numero?.trim(),
        anio: formulario.anio?.trim(),
        alcance: formulario.alcance?.trim(),
      },
    });
    let expediente = null;
    if (response.status == 200) {
      expediente = new Expediente(response.data);
    }
    emit('update:model-value', expediente);
  } catch (error) {
    console.log(error);
  }
  formEstado.isSearching = false;

  return rtaExp;
}

watchEffect(() => {
  // initForm()
  let isValid: Boolean = isValidForm();
  if (isValid) {
    if (props.validate) {
      getExpediente();
    } else {
      emit('update:model-value', new Expediente(formulario));
    }
  } else if (!formEstado.init) {
    emit('update:model-value', null);
  } else {
    formEstado.init = false;
  }
});

async function getExpediente() {
  const paramsRequest: any = {
    tipo: props.tipo,
    origen: form.expediente.origen,
    numero: form.expediente.numero?.trim(),
    anio: form.expediente.anio?.trim(),
    alcance: form.expediente.alcance?.trim()
  };
  let expedienteAux: Expediente = {};
  if (isValidForm()) {
    await http.get<Expediente>(props.urlServer + "getExpediente", paramsRequest)
      .then(function (response: AxiosResponse<Expediente>) {
        expedienteAux = new Expediente(response.data);
      })
      .catch(function (error: AxiosError<string>) {
        if (error.response) {
          // Request made and server responded
          if (error.response.data.indexOf("|") !== -1) {
            console.log(
              error.response.data.substring(
                error.response.data.indexOf("|") + 2,
                error.response.data.indexOf("Código") - 8
              ));
          } else {
            console.log(
              error.response.data.substring(
                error.response.data.indexOf("<h2>") + ("<h2>").length,
                error.response.data.indexOf("</h2>")
              ));
          }
          console.log("Error: request made and server responded");
          console.log(error.response);
          //console.log(error.response.status);
          //console.log(error.response.headers);
          //console.log(error.response.data);
        } else if (error.request) {
          // The request was made but no response was received          
          console.log("Error: the request was made but no response was received");
          console.log("Error desconocido. Por favor, avise al Administrador.");
          console.log(error.request);
        } else {
          // Something happened in setting up the request that triggered an Error          
          console.log("Error: something happened in setting up the request that triggered an error");
          console.log("Error desconocido. Por favor, avise al Administrador.");
          console.log(error);
        }
      });
  }
  form.expediente = expedienteAux;
}
*/

function clearExpediente() {
  form.expediente.id = null;
  formEstado.isUpdated = false;
  //emit('update:model-value', null);
}

/*
watch(props.modelValue, (newValue, oldValue) => {
  if (newValue !== oldValue) {
    if (props.validate) {
      if (props.tipo == undefined || tiposTablas.indexOf(props.tipo) == -1) {
        throw new Error("El tipo indicado no es válido.");
      }

      if (props.urlServer == undefined || props.urlServer.trim() == "") {
        throw new Error("Debe indicar la 'urlServer' del endpoint de validación.");
      }
    }
    formulario.origen = (props.modelValue != null && 'origen' in props.modelValue) ? props.modelValue.origen?.toString() : undefined; // TEXTO MAX 5 CARAC
    formulario.numero = (props.modelValue != null && 'numero' in props.modelValue) ? props.modelValue.numero?.toString() : undefined;; // NUMERO 6 DIGITOS
    formulario.anio = (props.modelValue != null && 'anio' in props.modelValue) ? props.modelValue.anio?.toString() : undefined; // TEXTO MAX 5 CARAC
    formulario.alcance = (props.modelValue != null && 'alcance' in props.modelValue) ? props.modelValue.alcance?.toString() : undefined;; // NUMERO 3 DIGITOS
  }
});
*/

</script>

<style scope lang="scss">
.remove-border {
  border-top-left-radius: 0px !important;
  border-bottom-left-radius: 0px !important;
}

// este CSS solo es necesario para poder utilizar el componente dentro de intranet. Dado
// que el archivo style.css sobreescribe estos estilos.
.was-validated .form-control:invalid,
.form-control.is-invalid {
  border-color: #dc3545 !important;
  padding-right: calc(1.5em + 0.75rem) !important;
  background-image: url("data:image/svg+xml,%3csvg xmlns='http://www.w3.org/2000/svg' viewBox='0 0 12 12' width='12' height='12' fill='none' stroke='%23dc3545'%3e%3ccircle cx='6' cy='6' r='4.5'/%3e%3cpath stroke-linejoin='round' d='M5.8 3.6h.4L6 6.5z'/%3e%3ccircle cx='6' cy='8.2' r='.6' fill='%23dc3545' stroke='none'/%3e%3c/svg%3e") !important;
  background-repeat: no-repeat !important;
  background-position: right calc(0.375em + 0.1875rem) center !important;
  background-size: calc(0.75em + 0.375rem) calc(0.75em + 0.375rem) !important;
}
</style>